<?php
header('Access-Control-Allow-Origin: *');
header("Access-Control-Allow-Methods: HEAD, GET, POST, PUT, PATCH, DELETE, OPTIONS");
header("Access-Control-Allow-Headers: X-API-KEY, Origin, X-Requested-With, Content-Type, Accept, Access-Control-Request-Method,Access-Control-Request-Headers, Authorization");
header('Content-Type: application/json');
$method = $_SERVER['REQUEST_METHOD'];
if ($method == "OPTIONS") {
    header('Access-Control-Allow-Origin: *');
    header("Access-Control-Allow-Headers: X-API-KEY, Origin, X-Requested-With, Content-Type, Accept, Access-Control-Request-Method,Access-Control-Request-Headers, Authorization");
    header("HTTP/1.1 200 OK");
    die();
}


$postjson = json_decode(file_get_contents('php://input'), true);
try {

    $cnpj = $postjson['cnpj'];
    $anoinicial = $postjson['at']['year'];
    $anofinal = $postjson['to']['year'];
    $mesinicial = $postjson['at']['month'];
    $mesfinal = $postjson['to']['month'];
    $dataInicial = $postjson['at']['complete'];
    $dataFinal = $postjson['to']['complete'];
    $modelo = $postjson['model'];


    $dataInicial = new DateTime($dataInicial);
    $dataFinal = new DateTime($dataFinal);

    $dataInicial = $dataInicial->format('Y-m-d');
    $dataFinal = $dataFinal->format('Y-m-d');

    //----- CAMINHO DA PASTA DOS XMLS
    $path = "../../xml/sincronizador/" . $cnpj . "/" . $modelo . "/" . $anoinicial . "/" . $mesinicial . "/";
    $diretorio = dir($path);
    if (!file_exists($path)) {
        $result = json_encode(array('success' => false, 'mensagem' => 'Desculpe, não encontramos notas para a data selecionada'));
        echo $result;
        return;
    }
    
    
    
    $canc = 0;
    
    //-----------------------------------------------------------------
    //------------------- LOOP PARA LER OS ARQUIVOS DENTRO DA PASTA ---
    //-----------------------------------------------------------------
    while ($arquivo = $diretorio->read()) {

        $xml = simplexml_load_file($path . "/" . $arquivo);
        $extensao = pathinfo($arquivo, PATHINFO_EXTENSION);
        

        //----- PEGA SOMENTE ARQUIVOS .XML
        if ($extensao == "xml") {

            $json = json_encode($xml);
            $array = json_decode($json, TRUE);
            
            

            //-----------------------------------------------------------------
            //------------------- TRATAMENTO DE CANCELADAS --------------------
            //-----------------------------------------------------------------
            if (isset($array['procEventoNFe'])) {
                $tpEvento = $array["procEventoNFe"]["evento"]["infEvento"]["tpEvento"];
                if ($tpEvento == "110111") {
                    $dataCancTemp = $array["procEventoNFe"]["evento"]["infEvento"]["dhEvento"];
                    $data = new DateTime($dataCancTemp);
                    $dataCanc = $data->format('Y-m-d');
                    
                    $chavecancelada = $array["procEventoNFe"]["evento"]["infEvento"]["chNFe"];
                
                    $canc++;
                }
                
                //---- PEGAR A CHAVE DAS CANCELADAS;
                $dados_cancelados[] = array(
                    'chavedanota'  => $chavecancelada,
                    'datadocancelamento' => $dataCanc
                );
                
            } else if (isset($array['evento'])) {
                $tpEvento = $array["evento"]["infEvento"]["tpEvento"];
                if ($tpEvento == "110111") {
                    $dataCancTemp = $array["evento"]["infEvento"]["dhEvento"];
                    $data = new DateTime($dataCancTemp);
                    $dataCanc = $data->format('Y-m-d');
                    
                    $chavecancelada = $array["evento"]["infEvento"]["chNFe"];
                    
                    $canc++;
                }
                
                //---- PEGAR A CHAVE DAS CANCELADAS;
                $dados_cancelados[] = array(
                    'chavedanota'  => $chavecancelada,
                    'datadocancelamento' => $dataCanc
                );
                
            }

            //-----------------------------------------------------------------
            //------------------- TRATAMENTO DAS AUTORIZADA -------------------
            //-----------------------------------------------------------------
            if (isset($array['NFe'])) {

                $numeroNota = $array["NFe"]["infNFe"]["ide"]["nNF"];
                $dataEmissao = $array["NFe"]["infNFe"]["ide"]["dhEmi"];
                $chaveNfe = $array["NFe"]["protNFe"]["infProt"]["chNFe"];
                $serie = $array["NFe"]["infNFe"]["ide"]["serie"];
                $valor = $array["NFe"]["infNFe"]["total"]["ICMSTot"]["vNF"];
                $modo = $array["NFe"]["infNFe"]["ide"]["tpEmis"];
                $modelo = $array["NFe"]["infNFe"]["ide"]["mod"];
                $data = new DateTime($dataEmissao);
                $dataTemp = $data->format('Y-m-d');

            } else {

                $numeroNota = $array["infNFe"]["ide"]["nNF"];
                $dataEmissao = $array["infNFe"]["ide"]["dhEmi"];
                $chaveNfe = $array["protNFe"]["infProt"]["chNFe"];
                $serie = $array["infNFe"]["ide"]["serie"];
                $valor = $array["infNFe"]["total"]["ICMSTot"]["vNF"];
                $modo = $array["infNFe"]["ide"]["tpEmis"];
                $modelo = $array["infNFe"]["ide"]["mod"];
                $data = new DateTime($dataEmissao);
                $dataTemp = $data->format('Y-m-d');

            }

            //-----------------------------------------------------------------
            //------------------- RETORNO DA LISTA DE NOTAS -------------------
            //-----------------------------------------------------------------
            if (strtotime($dataTemp) >= strtotime($dataInicial) && strtotime($dataTemp) <= strtotime($dataFinal)) {

                $dados[] = array(
                    'modelo'  => $modelo,
                    'numeroNota' => $numeroNota,
                    'dataEmissao' => $dataTemp,
                    'chave' => pathinfo($arquivo, PATHINFO_FILENAME),
                    'serie' => $serie,
                    'valor' => $valor,
                    'modo' => $modo,
                );
                
            }
            
        }


    }


    //-----------------------------------------------------------------
    //------------------- CORREÇÃO PASTA NAO EXISTE -------------------
    //-----------------------------------------------------------------
    if(is_dir("../../xml/sincronizador/" . $cnpj . "/" . $modelo . "/" . $anoinicial . "/" . "inut" . "/")){
    }else{
        mkdir("../../xml/sincronizador/" . $cnpj . "/" . $modelo . "/" . $anoinicial . "/" . "inut" . "/", 0777, true);
    }
    
    
    // //----- TRATAMENTO DE INUTILIZADAS - NÃO ESTA SENDO UTILIZADO - PERDA DE PERFORMACE
    // $pathInut = "../../xml/sincronizador/" . $cnpj . "/" . $modelo . "/" . $anoinicial . "/" . "inut" . "/";
    // $diretorioInut = dir($pathInut);
    // $inut = 0;
    // while ($arquivo = $diretorioInut->read()) {
    //     $xmlInut = simplexml_load_file($pathInut . "/" . $arquivo);
    //     $extensaoInut = pathinfo($arquivo, PATHINFO_EXTENSION);
    //     if ($extensaoInut == "xml") {
    //         $jsonInut = json_encode($xmlInut);
    //         $arrayInut = json_decode($jsonInut, TRUE);
    //         if (isset($arrayInut['ProcInutNFe'])) {
    //             $dataInutTemp = $arrayInut["retInutNFe"]["infInut"]["dhRecbto"];
    //             $data = new DateTime($dataInutTemp);
    //             $dataInut = $data->format('Y-m-d');
    //         } else if (isset($arrayInut['inutNFe'])) {
    //             $dataInutTemp = $arrayInut["retInutNFe"]["infInut"]["dhRecbto"];
    //             $data = new DateTime($dataInutTemp);
    //             $dataInut = $data->format('Y-m-d');
    //         }
    //         if (strtotime($dataInut) >= strtotime($dataInicial) && strtotime($dataInut) <= strtotime($dataFinal)) {
    //             $inut++;
    //         }
    //     }
    // }


    

    // //------- TOTAL DE NOTAS INUTILIZADAS
    // if ($inut > 0) {
        
    //     $dadosInut[] = array(
    //         'quant'  => $inut
    //     );
        
    // } else {
        
    //     $dadosInut[] = array(
    //         'quant'  => 0
    //     );
    // }
    
    
    //------- TOTAL DE NOTAS CANCELADAS
    if ($canc > 0) {
        
        $dadosCanc[] = array(
            'quant'  => $canc,
            
        );
        
    } else {
        
        $dadosCanc[] = array(
            'quant'  => 0,
            
        );
        
    }
    
    if ($dados == null) {
        $dados = [];
    }
    
    if ($dados_cancelados == null) {
        $dados_cancelados = [];
    }
    
    
   //----- NOVA FORMA DE TRAZER OS DADOS - Status - Valor - Se Foi Cancelada ou não.
    $soma_cancelados = 0;
    
    foreach($dados as $notas)
    {       
        
         foreach($dados_cancelados as $notascanceldas)
            {   
                if(preg_replace("/[^0-9]/", "", $notas['chave']) == preg_replace("/[^0-9]/", "", $notascanceldas['chavedanota'])){
                    $status = 'Cancelada';
                    $soma_cancelados +=  $notas['valor'];
                }else{
                    $status = 'Autorizada';
                }
            }
            
            if(empty($notas['valor'])){
            }else
            {
                $dadosdocancelamento[] = array(
                    "chave" => $notas['chave'],
                    "valor" => $notas['valor'],
                    "serie" => $notas['serie'],
                    "numeroNota" => $notas['numeroNota'],
                    "dataEmissao" => $notas['dataEmissao'],
                    "status" => $status
                );
            }
    }
   


    //----- RETORNA PARA API
    $result = json_encode(array('success' => true, 'canc' => $dadosCanc, 'autorizadas' => $dados, 'total_cancelado'=> $soma_cancelados));
    echo $result;


} catch (\Exception $th) {

    $result = json_encode(array('success' => false, 'mensagem' => $th), JSON_UNESCAPED_UNICODE);
    echo $result;

}
